// Generated by CoffeeScript 1.12.7
var feedback, scoring;

scoring = require('./scoring');

feedback = {
  default_feedback: {
    warning: '',
    suggestions: ["Nutzen Sie mehrere Wöreter, vermeiden Sie typische Phrasen", "Man muss nicht unbedingt Symbole, Nummern und große Buchstaben nutzen"]
  },
  get_feedback: function(score, sequence) {
    var extra_feedback, i, len, longest_match, match, ref;
    if (sequence.length === 0) {
      return this.default_feedback;
    }
    if (score > 2) {
      return {
        warning: '',
        suggestions: []
      };
    }
    longest_match = sequence[0];
    ref = sequence.slice(1);
    for (i = 0, len = ref.length; i < len; i++) {
      match = ref[i];
      if (match.token.length > longest_match.token.length) {
        longest_match = match;
      }
    }
    feedback = this.get_match_feedback(longest_match, sequence.length === 1);
    extra_feedback = 'Fügen Sie ein Paar Wörter dazu, untypische Wörter sind besser';
    if (feedback != null) {
      feedback.suggestions.unshift(extra_feedback);
      if (feedback.warning == null) {
        feedback.warning = '';
      }
    } else {
      feedback = {
        warning: '',
        suggestions: [extra_feedback]
      };
    }
    return feedback;
  },
  get_match_feedback: function(match, is_sole_match) {
    var layout, warning;
    switch (match.pattern) {
      case 'dictionary':
        return this.get_dictionary_match_feedback(match, is_sole_match);
      case 'spatial':
        layout = match.graph.toUpperCase();
        warning = match.turns === 1 ? 'Nacheinander folgende Tasten kann man leicht erraten' : 'Kurze Tastatur Kombinationen kann man leicht erraten';
        return {
          warning: warning,
          suggestions: ['Nutzen Sie eine längere Kombination, wenden Sie häufiger']
        };
      case 'repeat':
        warning = match.base_token.length === 1 ? 'Wiederholende Buchstaben sind sehr leicht zu erraten' : 'Wiederholungen wie "abcabcabc" sind unwessentlich besser als nur "abc"';
        return {
          warning: warning,
          suggestions: ['Vermeiden Sie wiederholende Wörter und Buchstaben']
        };
      case 'sequence':
        return {
          warning: "Sequenzen wie 6543 sind leicht zu erraten",
          suggestions: ['Vermeiden Sie Sequencen']
        };
      case 'regex':
        if (match.regex_name === 'recent_year') {
          return {
            warning: "Letze Jahre sind leicht zu erraten",
            suggestions: ['Vermeiden Sie letzte Jahre', 'Vermeiden Sie Jahre die mit Ihnen verbunden sind']
          };
        }
        break;
      case 'date':
        return {
          warning: "Dates are often easy to guess",
          suggestions: ['Vermeiden Sie Daten die mit Ihnen verbunden sind']
        };
    }
  },
  get_dictionary_match_feedback: function(match, is_sole_match) {
    var ref, ref1, result, suggestions, warning, word;
    warning = match.dictionary_name === 'passwords' ? is_sole_match && !match.l33t && !match.reversed ? match.rank <= 10 ? 'Das ist ein von sehr häufigste und einfachste Passwörter' : match.rank <= 100 ? 'Das ist ein von häufigste Passwörter' : 'Das ist ein von häufige Passwörter' : match.guesses_log10 <= 4 ? 'Das ist sehr ähnlich zu einem sehr häufigen Password' : void 0 : (ref = match.dictionary_name) === 'english_wikipedia' || ref === 'populaere' ? is_sole_match ? 'Das ist ein einfaches Wort' : void 0 : (ref1 = match.dictionary_name) === 'surnames' || ref1 === 'male_names' || ref1 === 'female_names' || ref1 === 'vornamen' || ref1 === 'nachnamen' ? is_sole_match ? 'Namen und Vornamen selbst sind sehr leicht zu erraten' : 'Häufige Namen sind leicht zu erraten' : '';
    suggestions = [];
    word = match.token;
    if (word.match(scoring.START_UPPER)) {
      suggestions.push("Große Buchstaben helfen nicht unbedingt");
    } else if (word.match(scoring.ALL_UPPER) && word.toLowerCase() !== word) {
      suggestions.push("Ein Passwort aus allen großen Buchstaben ist genau so leicht wie aus kleinen.");
    }
    if (match.reversed && match.token.length >= 4) {
      suggestions.push("Rückwärts schreiben hilft nicht");
    }
    if (match.l33t) {
      suggestions.push("Wenn man a auf @ ersetzt u.ä. bleibt das Passwort leicht zu erraten");
    }
    result = {
      warning: warning,
      suggestions: suggestions
    };
    return result;
  }
};

module.exports = feedback;

//# sourceMappingURL=feedback.js.map
